/*
		sub routine
	for ngv_save.win 1998 by Rick
*/

#include	<corlib.h>
#include	<string.h>
#include	<sys_doslib.h>

#include	"Sesse.c"

extern char	*mformat[5], *format[6], **curformat;
extern int	cwp, OneTime;

extern int cutwsave( char*, Sheet* );
extern int cutsave( char*, Sheet* );
extern int shtsave( char*, Sheet*, int );
extern int ttlsave( char*, Sheet* );
void	WaitMark();
void	Error( char* );
void	delcopy( void* );
int	shtcopy( Sheet*, Sheet* );
int	gvcopy( UGraphic*, UGraphic* );
int msave( char*, Sheet*, int );
int coercesave( char*, UGraphic*, int );
void	saveope( void*, char*, int );


static void
Error( msg )
char	*msg;
{
	ConsoleOpen();
	ConsolePrint( msg );
	ConsolePrint( "\r\n" );
}

static void
WaitMark()
{
	MouseSetPattern( 1, &SessePattern, 7, 3 );
	MS_SEL( 1 );
}

int
shtcopy( vs, gp )
Sheet	*vs;
Sheet	*gp;
{
	int	size= gp->hword * gp->v;	

	vs->buf1= (unsigned short*)MALLOC( size * sizeof( short ) * 2 );
	if( (int)vs->buf1 < 0 ){
		Error( "ngv_save: memory exhausted" );
		return FALSE;
	}
	vs->h= gp->h;
	vs->v= gp->v;
	vs->hword= gp->hword;
	vs->buf2= vs->buf1 + size;
	{
		int	x, y;
		unsigned short	*ptr1= gp->buf1, *ptr2= gp->buf2,
						*wtptr1= vs->buf1, *wtptr2= vs->buf2;
		for( y= 0 ; y < gp->v ; y++ ){
			for( x= 0 ; x < gp->hword ; x++ ){
				*wtptr1++= *ptr1++;
				*wtptr2++= *ptr2++;
			}
		}
	}
	return	TRUE;
}

int
gvcopy( vs, gp )
UGraphic	*vs;
UGraphic	*gp;
{
	vs->buf= (unsigned short*)MALLOC( gp->h * gp->v * 2 );
	if( (int)vs->buf < 0 ){
		Error( "ngv_save: memory exhausted" );
		return FALSE;
	}
	vs->h= gp->h;
	vs->v= gp->v;
	if( gp->color == WindowAttrGraphic65536 ){
		int	x, y;
		unsigned short	*ptr= gp->buf,
						*wtptr= vs->buf;
		for( y= 0 ; y< gp->v ; y++ ){
			for( x= 0 ; x< gp->h ; x++ ){
				*wtptr++= *ptr++;
			}
		}
	}else if( gp->palet ){
		int	x, y;
/*		int	oddflag= FALSE;	*/
		unsigned char	*ptr= (void*)gp->buf;
		unsigned short	*wtptr= vs->buf;
						
/*		if( gp->h & 1 )	oddflag= TRUE;	*/
		for( y= 0 ; y< gp->v ; y++ ){
			for( x= 0 ; x< gp->h ; x++ ){
				*wtptr++= gp->palet[*ptr++];
			}
/*			if( oddflag )	ptr++;	*/
		}
	}else{
			Error( "ngv_save: convert error" );
			return FALSE;
	}
	return	TRUE;
}

int
msave( filename, s, formnum )
char	*filename;
Sheet	*s;
int	formnum;
{
	if( !strchr( filename, '.' ) ){
		strcat( filename, "." );
		if( formnum == 3 ){
			strcat( filename, "cut" );
		}else {
			strcat( filename, mformat[formnum] );
		}
	}
	switch( formnum ){
	case 0:
		return shtsave( filename, s, 0 );
	case 1:
		return shtsave( filename, s, 1 );
	case 2:
		return cutsave( filename, s );
	case 3:
		return cutwsave( filename, s );
	case 4:
		return ttlsave( filename, s );
	}
	return	FALSE;
}

int
coercesave( file, gp, formnum )
char	*file;
UGraphic *gp;
int	formnum;
{
	unsigned char	*prog, cmdline[256];
	
	sprintf( cmdline, "-VS%d,%d,$%x", gp->h, gp->v, gp->buf );
	if( formnum == 2){
		prog= "jpeged.r";
		strcat( cmdline, " -S " );
	}else {
		prog= "coerce.x";
		strcat( cmdline, " +" );
		strcat( cmdline, format[formnum] );
		strcat( cmdline, " " );
	}
	if( !strrchr( file, '.' ) ){
		strcat( file, "." );
		strcat( file, format[formnum] );
	}
	strcat( cmdline, file );
	return WindowLoadExec( prog, cmdline, NULL, ConsoleChar );
}

void
saveope( vs, file, defform )
void	*vs;
char	*file;
int	defform;
{
	int	ret;

	if( *file ){
		WaitMark();
		if( curformat == format ){
			ret= coercesave( file, (UGraphic*)vs, defform );
		}else {
			ret= msave( file, (Sheet*)vs, defform );
		}
		if(	ret ){
			Error( "ngv_save: failed" );
		}else {
			Error( "ngv_save: saved" );
		}
		MS_SEL( 0 );
	}
}

void
closeope( wp, vs )
WindowID	wp;
void *vs;
{
	if(curformat == format){
		MFREE( (int)(((UGraphic*)vs)->buf) );
	}else {
		MFREE( (int)(((Sheet*)vs)->buf1) );
	}
	WindowClose( wp );
	cwp= NULL;
	if( OneTime )	WindowConnectionClose();
}
